# Copyright 2024 Cisco Systems, Inc. and its affiliates
from __future__ import annotations

from typing import Any, List

from catalystwan.abc import RequestAdapterInterface


class ApplicationsBuilder:
    """
    Builds and executes requests for operations under /device/dpi/qosmos-static/applications
    """

    def __init__(self, request_adapter: RequestAdapterInterface) -> None:
        self._request_adapter = request_adapter

    def get_qosmos_static_application_list(self, **kw) -> List[Any]:
        """
        Get DPI QoSMos static application list

        :returns: List[Any]
        """
        return self._request_adapter.request(
            "GET", "/dataservice/device/dpi/qosmos-static/applications", return_type=List[Any], **kw
        )
