# Copyright 2024 Cisco Systems, Inc. and its affiliates
from __future__ import annotations

from typing import Any, Optional

from catalystwan.abc import RequestAdapterInterface


class MultipleBuilder:
    """
    Builds and executes requests for operations under /template/policy/definition/acl/multiple
    """

    def __init__(self, request_adapter: RequestAdapterInterface) -> None:
        self._request_adapter = request_adapter

    def edit_multiple_policy_definition_8(
        self, id: str, payload: Optional[Any] = None, **kw
    ) -> Any:
        """
        Edit multiple policy definitions

        :param id: Policy Id
        :param payload: Policy definition
        :returns: Any
        """
        params = {
            "id": id,
        }
        return self._request_adapter.request(
            "PUT",
            "/dataservice/template/policy/definition/acl/multiple/{id}",
            params=params,
            payload=payload,
            **kw,
        )
